Description

History

#1 - 03/05/2013 04:09 PM - Constantin Asofiei
- % Done changed from 0 to 90
- File ca_upd20130305f.zip added

In 4GL, it is possible to support malformed label names, as in:

IF AVAILABLE tncy THEN
123abc:

DO:

END.

orasin:

abc$"&*123: do i = 1 to 10:
if i mod 2 = 0 then
next abc%$7&*123.
end.

(the later case does not go through the P2J parser, as it does't support these malformed symbols)

At this time, we need to provide support for the first case, when the label starts with a non-character element. To solve this, the simplest solution is to
prefix the label name with an underscore, if it was marked as malformed by the parser. The attached update does just that.

OTOH, at some point we will need to enance this to provide full support for malformed names for variables/functions/procedures/etc (as Greg has
mentioned on some other occasions).
#2 - 03/05/2013 04:18 PM - Constantin Asofiei

I'm putting this through conversion regression testing.

#3 - 03/05/2013 05:15 PM - Constantin Asofiei

Passed conversion regression testing.

#4 - 03/05/2013 06:02 PM - Greg Shah

I'm OK with the code. You can check it in and distribute.

#5 - 03/06/2013 01:52 AM - Constantin Asofiei
- % Done changed from 90 to 100

Committed to bzr revision 10247.

#6 - 03/06/2013 08:08 AM - Greg Shah
- Status changed from WIP to Closed

#7 - 11/16/2016 11:07 AM - Greg Shah

- Target version changed from Milestone 4 to Conversion Support for Server Features

#8 - 01/10/2019 09:31 AM - Greg Shah

The parser now handles a wide range of malformed symbols. These are marked with the "malformed" boolean annotation.
The following resource types are affected:

labels

frame names
query names
stream names
procedure names
function names

Conversion must be enhanced to handle all of the cases which can be matched now. The following token types are the only types that CANNOT be
matched at the beginning (or in the middle) of one of these symbols:

DOT
COLON
COMMA
EQUALS
LPARENS
RPARENS
NOT_EQ
LT

LTE

GT

GTE

All other tokens can be matched as the first token.
#9 - 01/10/2019 09:43 AM - Greg Shah

- % Done changed from 100 to 50

- Status changed from Closed to Hold

- Target version deleted (Conversion Support for Server Features)

- Start date deleted (03/05/2013)

Files

ca_upd20130305f.zip 2.1 KB

05/14/2024

03/05/2013

Constantin Asofiei

3/3


http://www.tcpdf.org

